Combined State and Parameter Reduction
======================================
## for Nonlinear Systems with an Application in Neuroscience

## (Companion Code)


### Compatibility: 

compatible with Matlab and Octave

### Usage:

#### Chapter 2 ( `code/ch2` )

`dimred` % compute and plot compression results

#### Chapter 5 ( `code/ch5` )

`vernval_emgr`   % compute emgr results

`vernval_optmor` % compute optmor results

`compare_rc`     % compute nonlinear rc ladder results

`ch5plot`        % plot results

#### Chapter 6 ( `code/ch6` )

`sigmoid` % compute and plot sigmoid

#### Chapter 7 ( `code/ch7` )

`hnm` % compute hyperbolic network model results

`mri` % compute fMRI & fNIRS DCM results

`eeg` % compute EEG & MEG DCM results

`ch7plot` % plot results

#### Chapter 8 ( `code/ch8` )

`ch8plot` % plot results

#### Appendix ( `code/app` )

`mri_siso` % compute fMRI & fNIRS forward model HSVs

`appplot`  % plot results


### Frameworks:

uses the **emgr** framework for computing empirical gramians from [http://gramian.de](gramian.de).

and the **optmor** framework for optimization-based combined reduction from [http://gramian.github.io/optmor](gramian.github.io/optmor)

### License:

Copyright (c) 2014-2016 Christian Himpe,

All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
