function ch2dimred()
% ch2dimred (chapter 2 dimension reduction)
% by Christian Himpe, 2015-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    addpath('../');

    I = imread('../../data/morbutton.png');

    I = (mean(I,3)); % Use flipud if upside down

    [U,D,V] = svd(I);

    figure;
    imagesc(I);
    colormap(bone);
    set(gca,'XTick',[0,600,1200],'YTick',[]);
    pbaspect([0.75,1,1]);
    set([gca; findall(gca,'Type','text')],'FontSize',20);
    print('-dpdf',['../../plots/',mfilename(),'_orig.pdf']);


    figure;
    loglog(diag(D),'linewidth',14,'Color',colors('red'));
    xlim([1,1200]);
    pbaspect([0.80,1,1]);
    set([gca; findall(gca,'Type','text')],'FontSize',20);
    print('-dpdf',['../../plots/',mfilename(),'_sing.pdf']);


    figure;
    j = 100;
    J = U(:,1:j)*D(1:j,1:j)*V(:,1:j)';
    imagesc(J);
    colormap(bone);
    set(gca,'XTick',[0,600,1200],'YTick',[]);
    pbaspect([0.75,1,1]);
    set([gca; findall(gca,'Type','text')],'FontSize',20);
    print('-dpdf',['../../plots/',mfilename(),'_ro30.pdf']);


    figure;
    j = 10;
    J = U(:,1:j)*D(1:j,1:j)*V(:,1:j)';
    imagesc(J);
    colormap(bone);
    set(gca,'XTick',[0,600,1200],'YTick',[]);
    pbaspect([0.75,1,1]);
    set([gca; findall(gca,'Type','text')],'FontSize',20);
    print('-dpdf',['../../plots/',mfilename(),'_ro10.pdf']);
end
