function sigmoid()
% sigmoid (chapter 6 sigmoid comparison)
% by Christian Himpe, 2015 ( http://gramian.de )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*

    addpath('../');

    x = linspace(-10,10,1000);
    k = [0.25;0.5;0.75;1.0];
    y = 0.5*tanh(0.5*k*x)+0.5;

    linewidth = 8;

    figure;
    plot(x,y(1,:),'Color',colors('red'),'linewidth',linewidth);
    hold on;
    plot(x,y(2,:),'Color',colors('orange'),'linewidth',linewidth);
    plot(x,y(3,:),'Color',colors('green'),'linewidth',linewidth);
    plot(x,y(4,:),'Color',colors('blue'),'linewidth',linewidth);
    hold off;
    ylim([-0.1,1.1]);
    l = legend('\kappa = 0.25','\kappa = 0.50','\kappa = 0.75','\kappa = 1.00','location','northwest');
    pbaspect([2,1,1]);
    set([gca;findall(gca, 'Type','text')],'FontSize',16);
    set(l,'FontSize',12);

    print('-dpdf','../../plots/ch6sigmoid.pdf');
end
