function [NON,LIN,OUT] = eeg_util(n,a,b)
% mri_util (Chapter 7 EEG & MEG Function Generator)
% by Christian Himpe, 2015-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    N = 10*n;

    taue = 4.0;
    taui = 16.0;
    He = 0.004;
    Hi = 0.032;

    r = 0.56;

    gamma1 = 64;
    gamma2 = 16;
    gamma3 = 128;
    gamma4 = 128;
    gamma5 = 64;

    TT = diag(1.0./[taue,taui,taue,taue,taui]);

    A0 = [zeros(N/2,N/2),eye(N/2);kron(-TT.*TT,eye(n)),kron(-2.0*TT,eye(n))];

    zz = zeros(n,n);

    Av = [zeros(N/2,N/2);...
         (He/taue)*gamma1*eye(n),zz,zz,zz,zz;...
         zz,(Hi/taui)*gamma2*eye(n),zz,zz,zz;...
         zz,zz,(He/taue)*gamma3*eye(n),zz,zz;...
         zz,zz,zz,(He/taue)*gamma4*eye(n),zz;...
         zz,zz,zz,zz,(Hi/taui)*gamma5*eye(n)] * 0.5;

    As = [zz,zz,zz,eye(n),-eye(n);...
          eye(n),-eye(n),zz,zz,zz;...
          zz,zz,zz,eye(n),-eye(n);...
          zz,zz,eye(n),zz,zz;...
          eye(n),-eye(n),zz,zz,zz] * r * 0.5;

    AvAs = Av*As;

    av = (He/taue)*gamma3*0.5;

    as = 0.5*r;

    avas = av*as;


    Afl = @(x,p) [zeros(7*n,1);...
                  avas*((a.*reshape(p,[n,n])))*x(7*n+1:8*n);...
                  zeros(2*n,1)];

    Afn = @(x,p) [zeros(7*n,1);...
                  av*((a.*reshape(p,[n,n])))*tanh(as*x(7*n+1:8*n));...
                  zeros(2*n,1)];

    B = [zeros(7*n,1);(He/taue)*b;zeros(2*n,1)];

    C = [zz,zz,zz,eye(n),-eye(n),zz,zz,zz,zz,zz];

    LIN = @(x,u,p) A0*x + AvAs*x(1:N/2) + Afl(x,p) + B*u;
    NON = @(x,u,p) A0*x + Av*tanh(As*x(1:N/2)) + Afn(x,p) + B*u;

    OUT = @(x,u,p) C*x;
end
