function [NON,NOU,LIN,OUT] = mri_util(n,a,b)
% mri_util (Chapter 7 fMRI & fNIRS Function Generator)
% by Christian Himpe, 2015-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    kappa = 0.65;
    gamma = 0.41;
    tau = 0.98;
    alpha = 0.32;
    rho = 0.34;

    rtau = 1.0/tau;
    ralpha = 1.0/alpha;

    V0 = 0.02;
    k1 = 7.0*rho;
    k2 = 2.0*rho - 0.2;

    NON = @(x,u,p) [((a.*reshape(p,[n,n])))*x(1:n)+b*u; ...
                     x(1:n) - kappa * x(n+1:2*n) - gamma * ( x(2*n+1:3*n) - 1.0 ); ...
                     x(n+1:2*n); ...
                     rtau * ( x(2*n+1:3*n) - x(3*n+1:4*n).^ralpha ); ...
                     rtau * ( x(2*n+1:3*n) .* (1.0 - (1.0 - rho).^(1.0 ./ x(2*n+1:3*n) ) ) ./ rho  - ( x(4*n+1:5*n) .* x(3*n+1:4*n).^(ralpha - 1.0) ) )];

    NOU = @(x,u,p) V0 * ( k1 * (1.0 - x(4*n+1:5*n)) + k2 * (1.0 - x(3*n+1:4*n)) );

    Ah = zeros(4*n,5*n);

    Ah(1:n,1:n) = eye(n);
    Ah(1:n,n+1:2*n) = -kappa * eye(n);
    Ah(1:n,2*n+1:3*n) = -gamma * eye(n);

    Ah(n+1:2*n,n+1:2*n) = eye(n);

    Ah(2*n+1:3*n,2*n+1:3*n) = (1.0/tau) * eye(n);
    Ah(2*n+1:3*n,3*n+1:4*n) = (-1.0/(tau*alpha)) * eye(n);

    Ah(3*n+1:4*n,2*n+1:3*n) = ((1.0 - (1.0-rho)*(1.0-log(1.0-rho)))/(tau*rho))*eye(n);
    Ah(3*n+1:4*n,3*n+1:4*n) = (-(1.0-alpha)/(tau*alpha)) * eye(n);
    Ah(3*n+1:4*n,4*n+1:5*n) = (-1.0/tau) * eye(n);

    C = zeros(n,5*n);

    C(1:n,3*n+1:4*n) = (V0*k1) * eye(n);
    C(1:n,4*n+1:5*n) = (-V0*k2) * eye(n);

    LIN = @(x,u,p) [((a.*reshape(p,[n,n])))*x(1:n)+b*u; ...
                    Ah*x];

    OUT = @(x,u,p) C * x;
end
