function V = gramschmidt(U)
% gram-schmidt (with re-iterated othogonalization)
% by Christian Himpe, 2015-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    m = size(U,2);
    V = U(:,1);

    for I=2:m

        w = U(:,I);

        for J=1:10

            w = w - V*(w'*V)';
            b = norm(w,2);
            w = w./b;
            if(b>0.1)
                break;
            end
        end

        V = [V,w];
    end
end

