function ERR = perror(ODE,DYN,OUT,T,X,U,P,UP,m)
% perror (parameter-space error evaluation)
% by Christian Himpe, 2014-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    M = size(UP,2);
    Q = size(P,2);

    TMP = zeros(3,floor(M/m),Q);

    for I=1:Q

        Y = ODE(DYN,OUT,T,X,U,P(:,I));

        n1 = norm(Y(:),1);
        n2 = norm(Y(:),2);
        n8 = norm(Y(:),Inf);

        j = 1;

        for J=[1,m:m:(M-m)]

            up = UP(:,1:J);
            vp = up';

            p = vp*P(:,I);

            y = ODE(DYN,OUT,T,X,U,up*p);

            TMP(1,j,I) = norm(Y(:)-y(:),1)/n1;
            TMP(2,j,I) = norm(Y(:)-y(:),2)/n2;
            TMP(3,j,I) = norm(Y(:)-y(:),Inf)/n8;

            j = j + 1;
        end
    end

    ERR = [sqrt(sum(TMP.^2,3));max(TMP(2,:,:),[],3)];
end 
