function plot_error(data,name,maxdim,minerr,ltext,lloc,islarge)
% plot_surf (plot error graphs)
% by Christian Himpe, 2014-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    % Render
    if(~isempty(name)), linewidth = 8; else, linewidth = 2; end;
    figure('Name',name,'NumberTitle','off');
    hold on;
    semilogy(data(1,:),'Color',colors('red'),'linewidth',linewidth); 
    semilogy(data(2,:),'Color',colors('green'),'linewidth',linewidth);
    if(size(data,1)>=3)
        semilogy(data(3,:),'Color',colors('blue'),'linewidth',linewidth);
    end
    if(size(data,1)==7)
        semilogy(data(5,:),'--','Color',colors('red'),'linewidth',linewidth);
        semilogy(data(6,:),'--','Color',colors('green'),'linewidth',linewidth);
        semilogy(data(7,:),'--','Color',colors('blue'),'linewidth',linewidth);
    end
    hold off;
    pbaspect([1+0.5*islarge,1.6,1]);
    set([gca; findall(gca,'Type','text')],'FontSize',16);
    h = legend(ltext,'location',lloc);
    set(h,'FontSize',12);

    % Axis
    m = size(data,2);
    xlim([1,m]);
    ylim([minerr,1]);
    subdiv = 5 + islarge*5;
    set(gca,'XTick',round(m/subdiv):round(m/subdiv):m);
    set(gca,'XTickLabel',[round(maxdim/subdiv):round(maxdim/subdiv):maxdim]);

    if(~isempty(name)), print('-dpdf',['../../plots/',name,'.pdf']); end;
end
