function plot_offline(data,name)
% plot_offline (plot offline timings bar graphs)
% by Christian Himpe, 2014-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    %% Common X-Axis Lead Numeral
    m1 = max(data{1},data{3});
    m2 = max(sum(data{2}),sum(data{4}));
    e1 = 10^(floor(log10(m1))-1);
    e2 = 10^(floor(log10(m2))-1);
    n1 = e1*ceil(m1/e1);
    n2 = e2*ceil(m2/e2);


    %% Gramian-Based
    figure('Name',name{1},'NumberTitle','off');
    h = barh([[data{1};0],[data{3};0]]','stacked');
    h = get(h,'children');
    set(h{1},'CData',[colors('red');colors('green')]);
    xlim([0,n1]);
    set(gca,'ytick',[],'YDir','reverse');
    set([gca; findall(gca,'Type','text')],'FontSize',20);
    xlabel('[s]');
    ylabel('   Linearized  Nonlinear   ');
    pbaspect([1,0.6,1]);
    if(~isempty(name)), print('-dpdf',['../../plots/',name{1},'.pdf']); end;


    %% Optimization-Based
    figure('Name',name{2},'NumberTitle','off');
    h = barh([data{2},data{4}]','stacked');
    h = get(h,'children');
    for I=1:max(numel(data{2}),numel(data{4})), set(h{I},'CData',[colors('orange');colors('blue')]); end
    xlim([0,n2]);
    set(gca,'ytick',[],'YDir','reverse');
    set([gca; findall(gca,'Type','text')],'FontSize',20);
    xlabel('[s]');
    ylabel('   Linearized  Nonlinear   ');
    pbaspect([1,0.6,1]);
    if(~isempty(name)), print('-dpdf',['../../plots/',name{2},'.pdf']); end
end
