function plot_sample(data,name,dashed)
% plot_sample (plot sample trajectory and error)
% by Christian Himpe, 2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    norm2 = @(m) sqrt(sum(abs(m).^2,1));

    linewidth = 12;

    n = floor((size(data,1)-1)*0.5);

    if(exist('dashed') && dashed==1)
        xdata = data(1,:);
        xdata(1:6:end) = NaN;
        xdata(2:6:end) = NaN;
        ydata = data(n+2:end,:);
        ydata(:,1:6:end) = NaN;
        xdata(:,2:6:end) = NaN;
    else
        xdata = data(1,:);
        ydata = data(n+2:end,:);
    end

    figure;
    h1 = plot(data(1,:),data(2:n+1,:));
    hold on;
    [hb,h3,h4] = plotyy(xdata,ydata,data(1,:),norm2(data(2:n+1,:)-data(n+2:end,:))./norm2(data(2:n+1,:)),@plot,@semilogy);
    hold off; 
    set(h1,'Color',colors('blue'),'linewidth',linewidth);
    set(h3,'Color',colors('orange'),'linewidth',linewidth);
    set(h4,'Color',colors('green'),'linewidth',linewidth);
    xlabel('Time');
    set(get(hb(2),'Ylabel'),'String','Error','FontSize',16);
    set([gca; findall(gca,'Type','text')],'FontSize',16);
    set(hb(1),'FontSize',20);
    set(hb(2),'FontSize',20);
    legend(h1,'FOM');
    l = legend(h3,'ROM');
    set(l,'FontSize',16);
    pbaspect([1.5,2.2,1]);
    print(['../../plots/',name,'.pdf'],'-dpdf');
end
