function plot_slice(data,name,maxdim,minerr)
% plot_slice (plot slice of error surface)
% by Christian Himpe, 2014-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    % Render
    if(~isempty(name)), linewidth = 8; else, linewidth = 2; end;

    figure('Name',name,'NumberTitle','off');
    semilogy(diag(data{1}),'Color',colors('red'),'linewidth',linewidth);
    hold on;
    semilogy(diag(data{2}),'Color',colors('orange'),'linewidth',linewidth);
    semilogy(diag(data{3}),'Color',colors('green'),'linewidth',linewidth);
    semilogy(diag(data{4}),'Color',colors('blue'),'linewidth',linewidth);
    hold off;
    pbaspect([1.5,1.6,1]);


    % Axis
    md = numel(diag(data{1}));
    mm = min(maxdim);
    subdiv = 4;
    xlim([1,md]);
    ylim([minerr,1]);
    set(gca,'XTick',round(md/subdiv):round(md/subdiv):md);
    set(gca,'XTickLabel',round(mm/subdiv):round(mm/subdiv):mm);
    set([gca; findall(gca,'Type','text')],'FontSize',14);
    legend('Nonlinear Gramian-Based', ...
           'Nonlinear Optimization-Based', ...
           'Linearized Gramian-Based', ...
           'Linearized Optimization-Based','location','southeast');

    if(~isempty(name)), print('-dpdf',['../../plots/',name,'.pdf']); end;
end
