function plot_surf(data,name,maxdim,minerr,islarge)
% plot_surf (plot error surfaces)
% by Christian Himpe, 2014-2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    % Preprocess
    subdiv = 4 + islarge;
    granul = 10 + islarge*10;
    [n,p] = size(data);
    data = data(1:round(n/granul):n,1:round(p/granul):p);

    % Render
    if(exist('name')), figure('Name',name,'NumberTitle','off'); else, figure; end;
    h = surf(data);
    set([gca; findall(gca,'Type','text')],'FontSize',12);
    pbaspect([1,1,4-2*islarge]);
    view(135,10);


    % X-Axis
    xlim([1,granul]);
    set(gca,'XTick',[round(granul/subdiv):round(granul/subdiv):granul]);
    set(gca,'XTickLabel',[round(maxdim(2)/subdiv):round(maxdim(2)/subdiv):maxdim(2)]);
    xlabel(' ');
    set(text(granul-0.3*granul,granul+0.3*granul,minerr,'Parameter'),'rotation',30 - 15*islarge,'horizontalalignment','center');


    % Y-Axis
    ylim([1,granul]);
    set(gca,'YTick',[round(granul/subdiv):round(granul/subdiv):granul]);
    set(gca,'YTickLabel',[round(maxdim(1)/subdiv):round(maxdim(1)/subdiv):maxdim(1)]);
    ylabel(' ');
    set(text(granul+0.4*granul,granul,minerr,'State'),'rotation',-30 + 15*islarge,'horizontalalignment','right');


    % Z-Axis & Coloring
    set(gca,'ZScale','log');
    zlim([minerr,1]);
    colormap(antijet);
    set(h,'CData',log10(get(h,'CData')));
    set(gca,'CLim',log10([minerr,1]));

    if(exist('name')), print('-dpdf',['../../plots/',name,'.pdf']); end;
end 
