function SAM = sample(ODE,DYN,OUT,T,X,U,P,UX,VX,UP)
% sample (ROM sample evaluation)
% by Christian Himpe, 2016 ( wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*
    t = 0:T(1):T(2);

    Y = ODE(DYN,OUT,T,X,U,P);

    if(nargin==7)
        SAM = [t;Y];
        return;
    end;

    dyn = @(x,u,p) VX*DYN(UX*x,u,p);
    out = @(x,u,p) OUT(UX*x,u,p);
    x = VX*X;
    p = UP'*P;

    y = ODE(dyn,out,T,x,U,UP*p);

    SAM = [t;Y;y];
end 
